# 8base web api token auth client

The 8base api token auth client for the `AuthProvider`.

## WebApiTokenAuthClient

<!-- Generated by documentation.js. Update this documentation by updating the source code. -->

#### Table of Contents

-   [WebApiTokenAuthClient](#webapitokenauthclient)
    -   [Parameters](#parameters)

### WebApiTokenAuthClient

Create instacne of the api token auth client

#### Parameters

-   `apiToken` **[string](https://developer.mozilla.org/docs/Web/JavaScript/Reference/Global_Objects/String)** Api Token generated in 8base app.

## Usage

```js
import { AuthContext, AuthProvider, type AuthContextProps } from '@8base/auth';
import { WebApiTokenAuthClient } form '@8base/web-api-token-auth-client';

  const authClient = new WebApiTokenAuthClient({
    apiToken: 'api-token',
  });

  ...

  <AuthProvider authClient={ authClient }>
    ...
      <AuthContext.Consumer>
        {
          (auth: AuthContextProps) => (<div />)
        }
      </AuthContext.Consumer>
    ...  
  </AuthProvider>
```
