"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebApiTokenAuthClient = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _webUtils = require("@8base/web-utils");

/**
 * Create instacne of the api token auth client
 * @param {string} apiToken Api Token generated in 8base app.
 */
var WebApiTokenAuthClient = function WebApiTokenAuthClient(_ref) {
  var _this = this;

  var apiToken = _ref.apiToken;
  (0, _classCallCheck2.default)(this, WebApiTokenAuthClient);
  (0, _defineProperty2.default)(this, "apiToken", void 0);
  (0, _defineProperty2.default)(this, "getAuthState",
  /*#__PURE__*/
  (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee() {
    return _regenerator.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", _webUtils.localStorageAccessor.getAuthState());

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));
  (0, _defineProperty2.default)(this, "setAuthState",
  /*#__PURE__*/
  function () {
    var _ref3 = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee2(state) {
      return _regenerator.default.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _webUtils.localStorageAccessor.setAuthState((0, _objectSpread2.default)({}, state, {
                token: _this.apiToken
              }));

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function (_x) {
      return _ref3.apply(this, arguments);
    };
  }());
  (0, _defineProperty2.default)(this, "purgeAuthState",
  /*#__PURE__*/
  (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee3() {
    return _regenerator.default.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _webUtils.localStorageAccessor.purgeAuthState();

            _webUtils.localStorageAccessor.setAuthState({
              token: _this.apiToken
            });

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  })));
  (0, _defineProperty2.default)(this, "checkIsAuthorized",
  /*#__PURE__*/
  (0, _asyncToGenerator2.default)(
  /*#__PURE__*/
  _regenerator.default.mark(function _callee4() {
    return _regenerator.default.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt("return", true);

          case 1:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  })));
  this.apiToken = apiToken;

  _webUtils.localStorageAccessor.setAuthState({
    token: apiToken
  });
};

exports.WebApiTokenAuthClient = WebApiTokenAuthClient;