import _objectSpread from "@babel/runtime/helpers/objectSpread";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import { localStorageAccessor } from '@8base/web-utils';

/**
 * Create instacne of the api token auth client
 * @param {string} apiToken Api Token generated in 8base app.
 */
var WebApiTokenAuthClient = function WebApiTokenAuthClient(_ref) {
  var _this = this;

  var apiToken = _ref.apiToken;

  _classCallCheck(this, WebApiTokenAuthClient);

  _defineProperty(this, "apiToken", void 0);

  _defineProperty(this, "getAuthState",
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee() {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            return _context.abrupt("return", localStorageAccessor.getAuthState());

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  })));

  _defineProperty(this, "setAuthState",
  /*#__PURE__*/
  function () {
    var _ref3 = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee2(state) {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              localStorageAccessor.setAuthState(_objectSpread({}, state, {
                token: _this.apiToken
              }));

            case 1:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2, this);
    }));

    return function (_x) {
      return _ref3.apply(this, arguments);
    };
  }());

  _defineProperty(this, "purgeAuthState",
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee3() {
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            localStorageAccessor.purgeAuthState();
            localStorageAccessor.setAuthState({
              token: _this.apiToken
            });

          case 2:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3, this);
  })));

  _defineProperty(this, "checkIsAuthorized",
  /*#__PURE__*/
  _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee4() {
    return _regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            return _context4.abrupt("return", true);

          case 1:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4, this);
  })));

  this.apiToken = apiToken;
  localStorageAccessor.setAuthState({
    token: apiToken
  });
};

export { WebApiTokenAuthClient };